<script lang="ts">
	import { run, preventDefault } from 'svelte/legacy';

	import { page } from '$app/stores'
	import type { PageData } from './$types'
	import { deserialize } from '$app/forms'
	import { startRegistration, startAuthentication } from '@simplewebauthn/browser'
	import TextEntry from '../../components/TextEntry.svelte'
	import FingerprintSvg from '../../components/FingerprintSVG.svelte'
	import { browser } from '$app/environment'
	import { invalidateAll } from '$app/navigation'
	import type { ActionResult } from '@sveltejs/kit'
	import { onMount } from 'svelte'
	import { submit } from '../../manualFormEnhancement'

	interface Props {
		data: PageData;
	}

	let { data }: Props = $props();
	let fidoEmail: string = $state('')
	let fidoEnabled: boolean = true
	let error: string = $state('')
	let showModal: boolean = $state(false)
	let modalVerify: boolean = $state(false)
	let verifyCode: string = $state('')
	
	let htmlForm: HTMLFormElement = $state()

	run(() => {
		if (verifyCode) {
			const regex = /([0-9a-fA-F]{8}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{12})/g.exec(
				verifyCode
			)

			if (regex && regex[1] && browser) {
				window.location.replace(`/login/verify?code=${regex[1]}`)
			}
		}
	});

	onMount(() => {
		fidoEmail = window.localStorage.getItem('email') || ''
	})

	function callSubmit(e: Event) {
		e.preventDefault()
		htmlForm.requestSubmit()
	}

	async function handleSubmit() {
		error = ''
		const result: ActionResult = await submit(htmlForm)

		if (result.type === 'success') {
			// re-run all `load` functions, following the successful update
			await invalidateAll()
		}

		fidoCallback({result})
	}

	async function fidoCallback(json: { result: Record<string, any> }) {
		console.log(json)
		const result = json.result
		const { url, intent } = result.data

		if (result.type === 'failure') {
			error = result.data.message || 'No error specified'
			return
		}

		if (intent === 'register') {
			return await register(url, result, fidoEmail)
		}

		if (intent === 'login') {
			return await login(url, result, fidoEmail)
		}
	}

	async function register(url: string, result: Record<string, any>, user: string) {
		try {
			const registration = await startRegistration(result.data.opts)

			const res = await fetch(url, {
				method: 'POST',
				body: JSON.stringify({ ...registration, intent: 'register', username: user }),
				headers: {
					accept: 'application/json',
					'Content-Type': 'application/json'
				}
			})

			if (res.status > 299) {
				const body = await res.json()
				error = body.message
				return
			}

			window.localStorage.setItem('email', fidoEmail)
			modalVerify = true
		} catch (e: any) {
			console.log(e)
			error = e.message
		}
	}

	async function login(url: string, result: Record<string, any>, user: string) {
		try {
			const authentication = await startAuthentication(result.data.opts)
			const res = await fetch(url, {
				method: 'POST',
				body: JSON.stringify({ ...authentication, intent: 'login', username: user }),
				headers: {
					accept: 'application/json',
					'Content-Type': 'application/json'
				}
			})
			window.localStorage.setItem('email', fidoEmail)
			window.location.replace('/')
		} catch (e: any) {
			console.log(e)
			error = 'Login was cancelled'
		}
	}
</script>

<main>
	<h1>Welcome to (Virtual Marathon)</h1>

	<div class="text">
		<p>Track your progress as you run, walk, or bike through virtual routes and explore epic destinations.</p>

		<p>
			Compete against friends or other users in friendly competitions to see who can reach the finish line first. Watch
			and cheer them on as they reach new milestones.
		</p>

		<p>Whether you're a seasoned athlete or just starting out, our Virtual Marathon app has something for everyone.</p>
	</div>

	{#if data.user?.name}
		<h1 class="rainbow">You're already logged in, {data.user.name} :D</h1>
	{:else if $page.url.searchParams.get('error')}
		<h4 class="error">{$page.url.searchParams.get('error')}</h4>
	{:else}
		<h2>Please log in using one of the options below</h2>
	{/if}

	<div class="buttons">
		<form method="POST" action="?/discord">
			<button class="discord" name="discord"><img alt="Discord Logo" src="/discord.svg" />Login with Discord</button>
		</form>

		<form method="POST" action="?/google">
			<button class="google-button">
				<img src="https://developers.google.com/identity/images/g-logo.png" alt="Google logo" />
				<span>Sign in with Google</span>
			</button>
		</form>

		{#if fidoEnabled}
			<button
				name="fido"
				value="new"
				class="fido"
				onclick={(e) => {
					showModal = true
				}}
			>
				<FingerprintSvg size="38px" />
				<span>Use fingerprint</span>
			</button>
		{/if}
	</div>

	<div
		id="overlay"
		class:open={showModal}
		onclick={() => {showModal = false; modalVerify = false}}
		onkeypress={() => {showModal = false; modalVerify = false}}
	></div>

	<div class:modal-show={showModal} id="myModal">
		{#if modalVerify}
			<TextEntry
				bind:value={verifyCode}
				name="code"
				title="Verification Code"
				description="Check your email for a confirmation link or paste the code here"
				backgroundColour="transparent"
				style="width: 100%"
			/>
		{:else}
			<form method="POST" bind:this={htmlForm} action="?/fido" onsubmit={preventDefault(handleSubmit)}>
				<TextEntry
					bind:value={fidoEmail}
					name="email"
					title="Email Address"
					backgroundColour="transparent"
					style="width: 100%"
				/>
				{#if error}
					<p class="error">{error}</p>
				{/if}
				<button class="empty" name="fido" value="new" ontouchstart={callSubmit}>
					<FingerprintSvg size="64px" />
				</button>
			</form>
		{/if}
	</div>
</main>

<style>
	main {
		margin: 1rem;
		margin-top: 2rem;
		display: grid;
		margin-top: 0;
	}

	h1,
	h2 {
		font-weight: 400;
		color: #ffffffaa;
	}

	p {
		color: #ffffff99;
		font-weight: 300;
		text-align: center;
		font-size: 1.2rem;
		margin-left: 2rem;
		margin-right: 2rem;
	}

	.empty {
		background-color: transparent;
		border: none;
	}

	.text {
		max-width: 800px;
		justify-self: center;
	}
	.error {
		color: #ee5646;
		font-weight: 400;
	}

	.buttons {
		display: flex;
		flex-direction: column;
		row-gap: 1rem;
	}

	.fido {
		background-color: #5395ff;
		border: none;
		color: #ffffff;
		font-family: Quicksand;
		font-weight: 400;
		text-align: center;
		display: inline-grid;
		grid-template-columns: 48px 1fr;
		grid-template-rows: 1fr;
		grid-template-areas: 'icon text';
		align-items: center;
		padding-right: 2rem;
		width: 18rem;
		height: 50px;
		column-gap: 1rem;
		font-size: 1.2rem;
		cursor: pointer;
		padding-top: 6px;
		padding-bottom: 6px;
		padding-left: 12px;
		margin-right: auto;
		margin-left: auto;
	}

	.discord {
		background-color: rgba(88, 101, 242, 1);
		border: none;
		color: #ffffff;
		font-family: Quicksand;
		font-weight: 400;
		text-align: center;
		display: inline-flex;
		align-items: center;
		padding-right: 2rem;
		width: 18rem;
		height: 50px;
		column-gap: 1rem;
		font-size: 1.2rem;
		cursor: pointer;
	}

	.discord:hover {
		background-color: rgba(88, 101, 242, 0.815);
	}

	.discord img {
		padding: 10px;
		height: 30px;
	}

	.google-button {
		display: inline-flex;
		align-items: center;
		padding-right: 2rem;
		font-family: Quicksand;
		font-weight: 400;
		height: 50px;
		border: none;
		border-radius: 2px;
		width: 18rem;
		background-color: #4285f4;
		color: #fff;
		cursor: pointer;
		column-gap: 1rem;
		font-size: 1.2rem;
	}

	.google-button:hover {
		background-color: #1a71fc;
	}

	.google-button img {
		width: 42px;
		height: 42px;
		border-radius: 2px;
	}

	.google-button span {
		width: 100%;
	}

	#myModal.modal-show {
		display: block;
	}

	#myModal {
		display: none;
		position: absolute;
		top: 50%;
		left: 50%;
		transform: translate(-50%, -50%);
		z-index: 9999;
		background-color: white;
		padding: 20px;
		grid-template-columns: 1fr auto auto;
		grid-template-areas: 'text cancel save';
		position: fixed;
		z-index: 99999;
		min-height: 3rem;
		background-color: #222;
		border-radius: 10px;
		border-style: none;
		padding: 0.5rem;
		padding-bottom: 2rem;
		box-shadow: 0 5px 10px 5px rgba(0, 0, 0, 0.5);
		width: 90%;
		max-width: 600px;
	}

	#overlay {
		display: none;
		position: fixed;
		top: 0;
		left: 0;
		width: 100%;
		height: 100%;
		background-color: rgba(0, 0, 0, 0.5);
		z-index: 9998;
	}

	#overlay.open {
		display: block !important;
	}
</style>
